from os import write as os_write, close as os_close, O_WRONLY as os_O_WRONLY, O_CREAT as os_O_CREAT, open as os_open, remove as os_remove
from twisted.web import resource, http
from NotificationScreen import NotificationScreen

class UploadResource(resource.Resource):
	FILENAME = "/tmp/logo.png"
	def __init__(self, session):
		self.session = session
		print "[dream Notifications] Initializing UploadResource"
		resource.Resource.__init__(self)

	def render_POST(self, req):
		print "[dream Notifications] Received POST"
		try:
			req.setResponseCode(http.OK)
			req.setHeader('Content-type', 'application/xhtml+xml;' )
			req.setHeader('charset', 'UTF-8')	
			ttl = req.args['title'][0]
			msg = req.args['msg'][0]
			dur = req.args['duration'][0]
			xpos = req.args['xpos'][0]
			ypos = req.args['ypos'][0]
			data = req.args['filename'][0]
			bkg = req.args['bkgcolor'][0]
			type = req.args['type'][0]
			skin = req.args['skin'][0]
			if not data:
				result = "ERROR"
				return result
			fd = os_open( self.FILENAME, os_O_WRONLY|os_O_CREAT )
			if fd:
				cnt = os_write(fd, data)
				os_close(fd)
			if cnt <= 0:
				try:
					os_remove(FILENAME)
				except OSError, oe:
					pass
				result = "ERROR"
			else:
				result = """<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n
					<e2simplexmlresult>\n
						<e2state>True</e2state>
						<e2statetext>%s</e2statetext>
					</e2simplexmlresult>\n""" % self.FILENAME
			print "[dream Notifications] Showing " + ttl
			self.session.open(NotificationScreen, picPath = "/tmp/logo.png", title = ttl, message = msg, timeout = int(dur), x = int(xpos), y = int(ypos), bkgColor = bkg, skn = skin)
			return result
		except Exception, e:
			print "[dream Notifications] Exception in UploadResource: " + str(e)
			pass


